Index: modules/m_xline.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/m_xline.c,v
retrieving revision 1.52
diff -b -u -r1.52 m_xline.c
--- modules/m_xline.c	25 May 2004 16:39:31 -0000	1.52
+++ modules/m_xline.c	19 Aug 2004 22:16:25 -0000
@@ -56,9 +56,12 @@
 static int mo_xline(struct Client *client_p, struct Client *source_p, int parc, const char *parv[]);
 static int ms_xline(struct Client *client_p, struct Client *source_p, int parc, const char *parv[]);
 static int me_xline(struct Client *client_p, struct Client *source_p, int parc, const char *parv[]);
-static int mo_unxline(struct Client *client_p, struct Client *source_p, int parc, const char *parv[]);
-static int ms_unxline(struct Client *client_p, struct Client *source_p, int parc, const char *parv[]);
-static int me_unxline(struct Client *client_p, struct Client *source_p, int parc, const char *parv[]);
+static int mo_unxline(struct Client *client_p, struct Client *source_p, int parc,
+		      const char *parv[]);
+static int ms_unxline(struct Client *client_p, struct Client *source_p, int parc,
+		      const char *parv[]);
+static int me_unxline(struct Client *client_p, struct Client *source_p, int parc,
+		      const char *parv[]);
 
 struct Message xline_msgtab = {
 	"XLINE", 0, 0, 0, MFLG_SLOW,
@@ -70,6 +73,7 @@
 };
 
 mapi_clist_av1 xline_clist[] =  { &xline_msgtab, &unxline_msgtab, NULL };
+
 DECLARE_MODULE_AV1(xline, NULL, NULL, xline_clist, NULL, NULL, "$Revision: 1.52 $");
 
 static int valid_xline(struct Client *, const char *, const char *);
@@ -77,8 +81,7 @@
 			const char *reason, int temp_time);
 static void write_xline(struct Client *source_p, struct ConfItem *aconf);
 static void propagate_xline(struct Client *source_p, const char *target,
-			int temp_time, const char *name, 
-			const char *type, const char *reason);
+			    int temp_time, const char *name, const char *type, const char *reason);
 static void cluster_xline(struct Client *source_p, int temp_time,
 			const char *name, const char *reason);
 
@@ -108,8 +111,7 @@
 
 	if(!IsOperXline(source_p))
 	{
-		sendto_one(source_p, form_str(ERR_NOPRIVS),
-			   me.name, source_p->name, "xline");
+		sendto_one(source_p, form_str(ERR_NOPRIVS), me.name, source_p->name, "xline");
 		return 0;
 	}
 
@@ -130,9 +132,9 @@
 	}
 
 	/* XLINE <gecos> ON <server> :<reason> */
-	if(parc >= loc+2 && !irccmp(parv[loc], "ON"))
+	if(parc >= loc + 2 && !irccmp(parv[loc], "ON"))
 	{
-		target_server = parv[loc+1];
+		target_server = parv[loc + 1];
 		loc += 2;
 	}
 
@@ -147,8 +149,7 @@
 
 	if(target_server != NULL)
 	{
-		propagate_xline(source_p, target_server, temp_time,
-				name, "2", reason);
+		propagate_xline(source_p, target_server, temp_time, name, "2", reason);
 
 		if(!match(target_server, me.name))
 			return 0;
@@ -199,8 +200,7 @@
 }
 
 static void
-handle_remote_xline(struct Client *source_p, int temp_time,
-			const char *name, const char *reason)
+handle_remote_xline(struct Client *source_p, int temp_time, const char *name, const char *reason)
 {
 	struct ConfItem *aconf;
 
@@ -215,8 +215,7 @@
 	if((aconf = find_xline(name, 0)) != NULL)
 	{
 		sendto_one(source_p, ":%s NOTICE %s :[%s] already X-Lined by [%s] - %s",
-				me.name, source_p->name, name, 
-				aconf->name, aconf->passwd);
+			   me.name, source_p->name, name, aconf->name, aconf->passwd);
 		return;
 	}
 
@@ -230,21 +229,18 @@
  * side effects - checks the xline for validity, erroring if needed
  */
 static int
-valid_xline(struct Client *source_p, const char *gecos,
-	    const char *reason)
+valid_xline(struct Client *source_p, const char *gecos, const char *reason)
 {
 	if(EmptyString(reason))
 	{
 		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
-			   get_id(&me, source_p), 
-			   get_id(source_p, source_p), "XLINE");
+			   get_id(&me, source_p), get_id(source_p, source_p), "XLINE");
 		return 0;
 	}
 
 	if(strchr(reason, ':') != NULL)
 	{
-		sendto_one_notice(source_p,
-				  ":Invalid character ':' in comment");
+		sendto_one_notice(source_p, ":Invalid character ':' in comment");
 		return 0;
 	}
 
@@ -261,8 +257,7 @@
 }
 
 void
-apply_xline(struct Client *source_p, const char *name, const char *reason,
-		int temp_time)
+apply_xline(struct Client *source_p, const char *name, const char *reason, int temp_time)
 {
 	struct ConfItem *aconf;
 
@@ -279,11 +274,9 @@
 
 		sendto_realops_flags(UMODE_ALL, L_ALL,
 			     "%s added temporary %d min. X-Line for [%s] [%s]",
-			     get_oper_name(source_p), temp_time / 60,
-			     name, reason);
+				     get_oper_name(source_p), temp_time / 60, name, reason);
 		ilog(L_KLINE, "X %s %d %s %s",
-			get_oper_name(source_p), temp_time / 60,
-			name, reason);
+		     get_oper_name(source_p), temp_time / 60, name, reason);
 		sendto_one_notice(source_p, ":Added temporary %d min. X-Line [%s]",
 				temp_time / 60, name);
 	}
@@ -292,12 +285,10 @@
 		write_xline(source_p, aconf);
 
 		sendto_realops_flags(UMODE_ALL, L_ALL, "%s added X-Line for [%s] [%s]",
-				get_oper_name(source_p), 
-				aconf->name, aconf->passwd);
+				     get_oper_name(source_p), aconf->name, aconf->passwd);
 		sendto_one_notice(source_p, ":Added X-Line for [%s] [%s]",
 					aconf->name, aconf->passwd);
-		ilog(L_KLINE, "X %s 0 %s %s",
-			get_oper_name(source_p), name, reason);
+		ilog(L_KLINE, "X %s 0 %s %s", get_oper_name(source_p), name, reason);
 	}
 
 	dlinkAddAlloc(aconf, &xline_conf_list);
@@ -327,8 +318,7 @@
 	}
 
 	ircsprintf(buffer, "\"%s\",\"0\",\"%s\",\"%s\",%ld\n",
-		   aconf->name, aconf->passwd,
-		   get_oper_name(source_p), CurrentTime);
+		   aconf->name, aconf->passwd, get_oper_name(source_p), CurrentTime);
 
 	if(fbputs(buffer, out) == -1)
 	{
@@ -343,17 +333,14 @@
 
 static void 
 propagate_xline(struct Client *source_p, const char *target,
-		int temp_time, const char *name, const char *type,
-		const char *reason)
+		int temp_time, const char *name, const char *type, const char *reason)
 {
 	if(!temp_time)
 	{
 		sendto_match_servs(source_p, target, CAP_CLUSTER, NOCAPS,
-					"XLINE %s %s %s :%s",
-					target, name, type, reason);
+				   "XLINE %s %s %s :%s", target, name, type, reason);
 		sendto_match_servs(source_p, target, CAP_ENCAP, CAP_CLUSTER,
-				"ENCAP %s XLINE %d %s 2 :%s",
-				target, temp_time, name, reason);
+				   "ENCAP %s XLINE %d %s 2 :%s", target, temp_time, name, reason);
 	}
 	else
 		sendto_match_servs(source_p, target, CAP_ENCAP, NOCAPS,
@@ -362,8 +349,7 @@
 }
 			
 static void
-cluster_xline(struct Client *source_p, int temp_time, const char *name,
-		const char *reason)
+cluster_xline(struct Client *source_p, int temp_time, const char *name, const char *reason)
 {
 	struct remote_conf *shared_p;
 	dlink_node *ptr;
@@ -381,8 +367,7 @@
 		if(!temp_time)
 		{
 			sendto_match_servs(source_p, shared_p->server, CAP_CLUSTER, NOCAPS,
-					"XLINE %s %s 2 :%s",
-					shared_p->server, name, reason);
+					   "XLINE %s %s 2 :%s", shared_p->server, name, reason);
 			sendto_match_servs(source_p, shared_p->server, CAP_ENCAP, CAP_CLUSTER,
 					"ENCAP %s XLINE %d %s 2 :%s",
 					shared_p->server, temp_time, name, reason);
@@ -403,22 +388,19 @@
 {
 	if(!IsOperXline(source_p))
 	{
-		sendto_one(source_p, form_str(ERR_NOPRIVS),
-			   me.name, source_p->name, "xline");
+		sendto_one(source_p, form_str(ERR_NOPRIVS), me.name, source_p->name, "xline");
 		return 0;
 	}
 
 	if(parc == 4 && !(irccmp(parv[2], "ON")))
 	{
-		propagate_generic(source_p, "UNXLINE", parv[3], CAP_CLUSTER,
-				"%s", parv[1]);
+		propagate_generic(source_p, "UNXLINE", parv[3], CAP_CLUSTER, "%s", parv[1]);
 
 		if(match(parv[3], me.name) == 0)
 			return 0;
 	}
 	else if(dlink_list_length(&cluster_conf_list))
-		cluster_generic(source_p, "UNXLINE", SHARED_UNXLINE, CAP_CLUSTER,
-				"%s", parv[1]);
+		cluster_generic(source_p, "UNXLINE", SHARED_UNXLINE, CAP_CLUSTER, "%s", parv[1]);
 
 	if(remove_temp_xline(source_p, parv[1]))
 		return 0;
@@ -438,8 +420,7 @@
 	/* parv[0]  parv[1]        parv[2]
 	 * oper     target server  gecos
 	 */
-	propagate_generic(source_p, "UNXLINE", parv[3], CAP_CLUSTER,
-			"%s", parv[2]);
+	propagate_generic(source_p, "UNXLINE", parv[3], CAP_CLUSTER, "%s", parv[2]);
 
 	if(!match(parv[1], me.name))
 		return 0;
@@ -493,14 +474,11 @@
 
 		if(!irccmp(aconf->name, name))
 		{
-			sendto_one_notice(source_p, 
-					":X-Line for [%s] is removed",
-					name);
+			sendto_one_notice(source_p, ":X-Line for [%s] is removed", name);
 			sendto_realops_flags(UMODE_ALL, L_ALL,
 					 "%s has removed the temporary X-Line for: [%s]",
 					 get_oper_name(source_p), name);
-			ilog(L_KLINE, "UX %s %s", 
-				get_oper_name(source_p), name);
+			ilog(L_KLINE, "UX %s %s", get_oper_name(source_p), name);
 			
 			free_conf(aconf);
 			dlinkDestroy(ptr, &xline_conf_list);
@@ -532,8 +510,7 @@
 	int found_xline = 0;
 
 	filename = ConfigFileEntry.xlinefile;
-	ircsnprintf(temppath, sizeof(temppath),
-		 "%s.tmp", ConfigFileEntry.xlinefile);
+	ircsnprintf(temppath, sizeof(temppath), "%s.tmp", ConfigFileEntry.xlinefile);
 
 	if((in = fbopen(filename, "r")) == NULL)
 	{
@@ -553,7 +530,7 @@
 
 	umask(oldumask);
 
-	while (fbgets(buf, sizeof(buf), in))
+	while(fbgets(buf, sizeof(buf), in))
 	{
 		if(error_on_write)
 		{
@@ -592,8 +569,7 @@
 
 	if(error_on_write)
 	{
-		sendto_one_notice(source_p,
-				  ":Couldn't write temp xline file, aborted");
+		sendto_one_notice(source_p, ":Couldn't write temp xline file, aborted");
 		return;
 	}
 	else if(found_xline == 0)
Index: modules/core/m_die.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/m_die.c,v
retrieving revision 1.46
diff -b -u -r1.46 m_die.c
--- modules/core/m_die.c	15 Mar 2004 17:58:06 -0000	1.46
+++ modules/core/m_die.c	19 Aug 2004 22:16:25 -0000
@@ -47,6 +47,7 @@
 };
 
 mapi_clist_av1 die_clist[] = { &die_msgtab, NULL };
+
 DECLARE_MODULE_AV1(die, NULL, NULL, die_clist, NULL, NULL, "$Revision: 1.46 $");
 
 /*
@@ -60,8 +61,7 @@
 
 	if(!IsOperDie(source_p))
 	{
-		sendto_one(source_p, form_str(ERR_NOPRIVS),
-			   me.name, source_p->name, "die");
+		sendto_one(source_p, form_str(ERR_NOPRIVS), me.name, source_p->name, "die");
 		return 0;
 	}
 
Index: modules/core/m_error.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/m_error.c,v
retrieving revision 1.9
diff -b -u -r1.9 m_error.c
--- modules/core/m_error.c	29 Mar 2004 12:16:58 -0000	1.9
+++ modules/core/m_error.c	19 Aug 2004 22:16:25 -0000
@@ -112,8 +112,7 @@
 	else
 	{
 		sendto_realops_flags(UMODE_ALL, L_ADMIN, "ERROR :from %s via %s -- %s",
-				source_p->name, 
-				get_server_name(client_p, HIDE_IP), para);
+				     source_p->name, get_server_name(client_p, HIDE_IP), para);
 
 		if(!ConfigFileEntry.hide_error_messages)
 			sendto_realops_flags(UMODE_ALL, L_OPER,
Index: modules/core/m_join.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/Attic/m_join.c,v
retrieving revision 1.156
diff -b -u -r1.156 m_join.c
--- modules/core/m_join.c	25 Jul 2004 01:29:21 -0000	1.156
+++ modules/core/m_join.c	19 Aug 2004 22:16:25 -0000
@@ -52,6 +52,7 @@
 };
 
 mapi_clist_av1 join_clist[] = { &join_msgtab, NULL };
+
 DECLARE_MODULE_AV1(join, NULL, NULL, join_clist, NULL, NULL, "$Revision: 1.156 $");
 
 static void do_join_0(struct Client *client_p, struct Client *source_p);
@@ -90,15 +91,13 @@
 	 * this code has a side effect of losing keys, but..
 	 */
 	chanlist = LOCAL_COPY(parv[1]);
-	for(i = 0, name = strtoken(&p, chanlist, ","); name;
-	    name = strtoken(&p, NULL, ","))
+	for(i = 0, name = strtoken(&p, chanlist, ","); name; name = strtoken(&p, NULL, ","))
 	{
 		/* check the length and name of channel is ok */
 		if(!check_channel_name_loc(source_p, name) || (strlen(name) > LOC_CHANNELLEN))
 		{
 			sendto_one_numeric(source_p, ERR_BADCHANNAME,
-					   form_str(ERR_BADCHANNAME),
-					   (unsigned char *) name);
+					   form_str(ERR_BADCHANNAME), (unsigned char *) name);
 			continue;
 		}
 
@@ -118,7 +117,8 @@
 		}
 
 		/* see if its resv'd */
-		if((aconf = hash_find_resv(name)) && (!IsOper(source_p) || !ConfigChannel.no_oper_resvs))
+		if((aconf = hash_find_resv(name))
+		   && (!IsOper(source_p) || !ConfigChannel.no_oper_resvs))
 		{
 			sendto_one_numeric(source_p, ERR_BADCHANNAME,
 					form_str(ERR_BADCHANNAME), name);
@@ -140,7 +140,7 @@
 		if(*jbuf)
 			(void) strcat(jbuf, ",");
 		(void) strlcat(jbuf, name, sizeof(jbuf) - i - 1);
-		i += strlen(name)+1;
+		i += strlen(name) + 1;
 	}
 
 	if(parc > 2)
@@ -187,10 +187,10 @@
 		}
 
 		if((dlink_list_length(&source_p->user->channel) >= 
-					(unsigned long)ConfigChannel.max_chans_per_user) &&
+		    (unsigned long) ConfigChannel.max_chans_per_user) &&
 		   (!IsOper(source_p) || 
 		    (dlink_list_length(&source_p->user->channel) >=
-				 (unsigned long)ConfigChannel.max_chans_per_user * 3)))
+		     (unsigned long) ConfigChannel.max_chans_per_user * 3)))
 		{
 			sendto_one(source_p, form_str(ERR_TOOMANYCHANNELS),
 				   me.name, source_p->name, name);
@@ -222,8 +222,7 @@
 		/* can_join checks for +i key, bans etc */
 		if((i = can_join(source_p, chptr, key)))
 		{
-			sendto_one(source_p, form_str(i),
-				   me.name, source_p->name, name);
+			sendto_one(source_p, form_str(i), me.name, source_p->name, name);
 			if(successful_join_count > 0)
 				successful_join_count--;
 			continue;
@@ -268,15 +267,13 @@
 			sendto_server(client_p, chptr, CAP_TS6, NOCAPS,
 				      ":%s JOIN %ld %s %s %s",
 				      use_id(source_p), (long) chptr->channelts,
-				      chptr->chname, modebuf,
-				      parabuf[0] == '\0' ? "" : parabuf);
+				      chptr->chname, modebuf, parabuf[0] == '\0' ? "" : parabuf);
 
 			sendto_server(client_p, chptr, NOCAPS, CAP_TS6,
 				      ":%s SJOIN %ld %s %s %s:%s",
 				      me.name, (long) chptr->channelts,
 				      chptr->chname, modebuf,
-				      parabuf[0] == '\0' ? "" : parabuf, 
-				      source_p->name);
+				      parabuf[0] == '\0' ? "" : parabuf, source_p->name);
 		}
 
 		del_invite(chptr, source_p);
@@ -346,7 +343,7 @@
 	mode.mode = mode.limit = 0;
 
 	s = parv[3];
-	while (*s)
+	while(*s)
 	{
 		switch (*(s++))
 		{
@@ -447,13 +444,13 @@
 		remove_our_modes(chptr, source_p);
 		sendto_channel_local(ALL_MEMBERS, chptr,
 				     ":%s NOTICE %s :*** Notice -- TS for %s changed from %ld to %ld",
-				     me.name, chptr->chname, chptr->chname, (long) oldts, (long) newts);
+				     me.name, chptr->chname, chptr->chname, (long) oldts,
+				     (long) newts);
 	}
 
 	if(*modebuf != '\0')
 		sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s %s %s",
-				     source_p->user->server,
-				     chptr->chname, modebuf, parabuf);
+				     source_p->user->server, chptr->chname, modebuf, parabuf);
 
 	*modebuf = *parabuf = '\0';
 	channel_modes(chptr, client_p, modebuf, parabuf);
@@ -468,8 +465,7 @@
 
 	sendto_server(client_p, chptr, CAP_TS6, NOCAPS,
 		      ":%s JOIN %ld %s %s %s",
-		      source_p->id, (long) chptr->channelts, chptr->chname,
-		      modebuf, parabuf);
+		      source_p->id, (long) chptr->channelts, chptr->chname, modebuf, parabuf);
 	sendto_server(client_p, chptr, NOCAPS, CAP_TS6,
 		      ":%s SJOIN %ld %s %s %s:%s",
 		      source_p->user->server, (long) chptr->channelts,
@@ -505,7 +501,7 @@
 	   !IsOper(source_p) && !IsExemptSpambot(source_p))
 		check_spambot_warning(source_p, NULL);
 
-	while ((ptr = source_p->user->channel.head))
+	while((ptr = source_p->user->channel.head))
 	{
 		msptr = ptr->data;
 		chptr = msptr->chptr;
@@ -525,7 +521,7 @@
 
 	if(ConfigFileEntry.disable_fake_channels && !IsOper(source_p))
 	{
-		for (; *name; ++name)
+		for(; *name; ++name)
 		{
 			if(!IsChanChar(*name) || IsFakeChanChar(*name))
 				return 0;
@@ -568,7 +564,7 @@
 	int i;
 
 	/* ok, first get a list of modes we need to add */
-	for (i = 0; flags[i].letter; i++)
+	for(i = 0; flags[i].letter; i++)
 	{
 		if((mode->mode & flags[i].mode) && !(oldmode->mode & flags[i].mode))
 		{
@@ -582,7 +578,7 @@
 	}
 
 	/* now the ones we need to remove. */
-	for (i = 0; flags[i].letter; i++)
+	for(i = 0; flags[i].letter; i++)
 	{
 		if((oldmode->mode & flags[i].mode) && !(mode->mode & flags[i].mode))
 		{
@@ -699,6 +695,12 @@
 				*mbuf++ = 'v';
 			}
 		}
+		else if(is_halfop(msptr))
+		{
+			msptr->flags &= ~CHFL_HALFOP;
+			lpara[count++] = msptr->client_p->name;
+			*mbuf++ = 'h';
+		}
 		else if(is_voiced(msptr))
 		{
 			msptr->flags &= ~CHFL_VOICE;
Index: modules/core/m_kick.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/Attic/m_kick.c,v
retrieving revision 1.79
diff -b -u -r1.79 m_kick.c
--- modules/core/m_kick.c	14 Apr 2004 16:35:11 -0000	1.79
+++ modules/core/m_kick.c	19 Aug 2004 22:16:25 -0000
@@ -48,6 +48,7 @@
 };
 
 mapi_clist_av1 kick_clist[] = { &kick_msgtab, NULL };
+
 DECLARE_MODULE_AV1(kick, NULL, NULL, kick_clist, NULL, NULL, "$Revision: 1.79 $");
 
 /*
@@ -60,7 +61,7 @@
 static int
 m_kick(struct Client *client_p, struct Client *source_p, int parc, const char *parv[])
 {
-	struct membership *msptr;
+	struct membership *msptr = NULL;
 	struct Client *who;
 	struct Channel *chptr;
 	int chasing = 0;
@@ -86,8 +87,7 @@
 	chptr = find_channel(name);
 	if(chptr == NULL)
 	{
-		sendto_one_numeric(source_p, ERR_NOSUCHCHANNEL,
-				   form_str(ERR_NOSUCHCHANNEL), name);
+		sendto_one_numeric(source_p, ERR_NOSUCHCHANNEL, form_str(ERR_NOSUCHCHANNEL), name);
 		return 0;
 	}
 
@@ -102,7 +102,7 @@
 			return 0;
 		}
 
-		if(!is_chanop(msptr))
+		if(!is_chanop(msptr) && !is_halfop(msptr))
 		{
 			if(MyConnect(source_p))
 			{
@@ -115,8 +115,7 @@
 			if(chptr->channelts == 0)
 			{
 				sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
-					   get_id(&me, source_p), 
-					   get_id(source_p, source_p), name);
+					   get_id(&me, source_p), get_id(source_p, source_p), name);
 				return 0;
 			}
 		}
@@ -153,6 +152,13 @@
 		return 0;
 	}
 
+	if(!is_halfop(msptr))
+	{
+		/* dougk_ff7
+		 * - This is getting shoved in at this point because msptr
+		 *   is getting recycled, and instead of allocate a new
+		 *   pointer, why not just do this?
+		 */
 	msptr = find_channel_membership(chptr, who);
 
 	if(msptr != NULL)
@@ -175,8 +181,7 @@
 
 		sendto_server(client_p, chptr, CAP_TS6, NOCAPS,
 			      ":%s KICK %s %s :%s", 
-			      use_id(source_p), chptr->chname, 
-			      use_id(who), comment);
+				      use_id(source_p), chptr->chname, use_id(who), comment);
 		sendto_server(client_p, chptr, NOCAPS, CAP_TS6,
 			      ":%s KICK %s %s :%s", 
 			      source_p->name, chptr->chname, who->name, comment);
@@ -185,7 +190,50 @@
 	else
 		sendto_one_numeric(source_p, ERR_USERNOTINCHANNEL,
 				   form_str(ERR_USERNOTINCHANNEL), user, name);
+	}
+	else
+	{
+		msptr = find_channel_membership(chptr, who);
 
+		if(msptr != NULL)
+		{
+			/* jdc
+			 * - In the case of a server kicking a user (i.e. CLEARCHAN),
+			 *   the kick should show up as coming from the server which did
+			 *   the kick.
+			 * - Personally, flame and I believe that server kicks shouldn't
+			 *   be sent anyways.  Just waiting for some oper to abuse it...
+			 */
+			if(is_chanop(msptr) && MyConnect(source_p))
+			{
+				/* dougk_ff7
+				 * - A bit of logic to prevent kicks of opped users.
+				 */
+				sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
+					   me.name, source_p->name, name);
 	return 0;
-}
+			}
+			if(IsServer(source_p))
+				sendto_channel_local(ALL_MEMBERS, chptr, ":%s KICK %s %s :%s",
+						     source_p->name, name, who->name, comment);
+			else
+				sendto_channel_local(ALL_MEMBERS, chptr,
+						     ":%s!%s@%s KICK %s %s :%s",
+						     source_p->name, source_p->username,
+						     source_p->host, name, who->name, comment);
+
+			sendto_server(client_p, chptr, CAP_TS6, NOCAPS,
+				      ":%s KICK %s %s :%s",
+				      use_id(source_p), chptr->chname, use_id(who), comment);
+			sendto_server(client_p, chptr, NOCAPS, CAP_TS6,
+				      ":%s KICK %s %s :%s",
+				      source_p->name, chptr->chname, who->name, comment);
+			remove_user_from_channel(msptr);
+		}
+		else
+			sendto_one_numeric(source_p, ERR_USERNOTINCHANNEL,
+					   form_str(ERR_USERNOTINCHANNEL), user, name);
+	}
 
+	return 0;
+}
Index: modules/core/m_kill.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/m_kill.c,v
retrieving revision 1.102
diff -b -u -r1.102 m_kill.c
--- modules/core/m_kill.c	25 May 2004 10:49:52 -0000	1.102
+++ modules/core/m_kill.c	19 Aug 2004 22:16:26 -0000
@@ -54,6 +54,7 @@
 };
 
 mapi_clist_av1 kill_clist[] = { &kill_msgtab, NULL };
+
 DECLARE_MODULE_AV1(kill, NULL, NULL, kill_clist, NULL, NULL, "$Revision: 1.102 $");
 
 /*
@@ -74,8 +75,7 @@
 
 	if(!IsOperLocalKill(source_p))
 	{
-		sendto_one(source_p, form_str(ERR_NOPRIVS),
-			   me.name, source_p->name, "local_kill");
+		sendto_one(source_p, form_str(ERR_NOPRIVS), me.name, source_p->name, "local_kill");
 		return 0;
 	}
 
@@ -132,8 +132,7 @@
 
 	ilog(L_KILL, "%c %s %s!%s@%s %s %s",
 		MyConnect(target_p) ? 'L' : 'G', get_oper_name(source_p),
-		target_p->name, target_p->username, target_p->host,
-		target_p->user->server, reason);
+	     target_p->name, target_p->username, target_p->host, target_p->user->server, reason);
 
 	/*
 	 ** And pass on the message to other servers. Note, that if KILL
@@ -213,12 +212,10 @@
 		if(IsDigit(*user) || (!(target_p = get_history(user, (long) KILLCHASETIMELIMIT))))
 		{
 			sendto_one_numeric(source_p, ERR_NOSUCHNICK, 
-					   form_str(ERR_NOSUCHNICK), 
-					   IsDigit(*user) ? "*" : user);
+					   form_str(ERR_NOSUCHNICK), IsDigit(*user) ? "*" : user);
 			return 0;
 		}
-		sendto_one_notice(source_p, ":KILL changed from %s to %s",
-				  user, target_p->name);
+		sendto_one_notice(source_p, ":KILL changed from %s to %s", user, target_p->name);
 		chasing = 1;
 	}
 
@@ -292,11 +289,9 @@
 	if(MyClient(source_p))
 		ircsnprintf(buffer, sizeof(buffer),
 			    "%s!%s!%s!%s (%s)",
-			    me.name, source_p->host, source_p->username,
-			    source_p->name, reason);
+			    me.name, source_p->host, source_p->username, source_p->name, reason);
 	else
-		ircsnprintf(buffer, sizeof(buffer),
-			    "%s %s", inpath, reason);
+		ircsnprintf(buffer, sizeof(buffer), "%s %s", inpath, reason);
 
 	DLINK_FOREACH(ptr, serv_list.head)
 	{
@@ -306,7 +301,6 @@
 			continue;
 
 		sendto_one(client_p, ":%s KILL %s :%s",
-			   get_id(source_p, client_p),
-			   get_id(target_p, client_p), buffer);
+			   get_id(source_p, client_p), get_id(target_p, client_p), buffer);
 	}
 }
Index: modules/core/m_message.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/m_message.c,v
retrieving revision 1.147.2.1
diff -b -u -r1.147.2.1 m_message.c
--- modules/core/m_message.c	3 Aug 2004 02:01:50 -0000	1.147.2.1
+++ modules/core/m_message.c	19 Aug 2004 22:16:26 -0000
@@ -56,6 +56,7 @@
 };
 
 mapi_clist_av1 message_clist[] = { &privmsg_msgtab, &notice_msgtab, NULL };
+
 DECLARE_MODULE_AV1(message, NULL, NULL, message_clist, NULL, NULL, "$Revision: 1.147.2.1 $");
 
 struct entity
@@ -97,7 +98,8 @@
 		       struct Client *source_p, struct Client *target_p, const char *text);
 
 static void handle_special(int p_or_n, const char *command,
-			 struct Client *client_p, struct Client *source_p, const char *nick, const char *text);
+			   struct Client *client_p, struct Client *source_p, const char *nick,
+			   const char *text);
 
 /*
 ** m_privmsg
@@ -165,8 +167,7 @@
 	/* Finish the flood grace period if theyre not messaging themselves
 	 * as some clients (ircN) do this as a "lag check"
 	 */
-	if(MyClient(source_p) && !IsFloodDone(source_p) &&
-	   irccmp(source_p->name, parv[1]))
+	if(MyClient(source_p) && !IsFloodDone(source_p) && irccmp(source_p->name, parv[1]))
 		flood_endgrace(source_p);
 
 	if(build_target_list(p_or_n, command, client_p, source_p, parv[1], parv[2]) < 0)
@@ -174,7 +175,7 @@
 		return 0;
 	}
 
-	for (i = 0; i < ntargets; i++)
+	for(i = 0; i < ntargets; i++)
 	{
 		switch (targets[i].type)
 		{
@@ -230,7 +231,7 @@
 
 	ntargets = 0;
 
-	for (nick = strtoken(&p, target_list, ","); nick; nick = strtoken(&p, NULL, ","))
+	for(nick = strtoken(&p, target_list, ","); nick; nick = strtoken(&p, NULL, ","))
 	{
 		char *with_prefix;
 		/*
@@ -290,10 +291,12 @@
 		type = 0;
 		with_prefix = nick;
 		/*  allow %+@ if someone wants to do that */
-		for (;;)
+		for(;;)
 		{
 			if(*nick == '@')
 				type |= CHFL_CHANOP;
+			else if(*nick == '%')
+				type |= CHFL_CHANOP | CHFL_HALFOP;
 			else if(*nick == '+')
 				type |= CHFL_CHANOP | CHFL_VOICE;
 			else
@@ -386,7 +389,7 @@
 duplicate_ptr(void *ptr)
 {
 	int i;
-	for (i = 0; i < ntargets; i++)
+	for(i = 0; i < ntargets; i++)
 		if(targets[i].ptr == ptr)
 			return YES;
 	return NO;
@@ -405,7 +408,8 @@
  */
 static void
 msg_channel(int p_or_n, const char *command,
-	    struct Client *client_p, struct Client *source_p, struct Channel *chptr, const char *text)
+	    struct Client *client_p, struct Client *source_p, struct Channel *chptr,
+	    const char *text)
 {
 	int result;
 
@@ -423,8 +427,7 @@
 		   !flood_attack_channel(p_or_n, source_p, chptr, chptr->chname))
 		{
 			sendto_channel_flags(client_p, ALL_MEMBERS, source_p, chptr, 
-					      "%s %s :%s",
-					      command, chptr->chname, text);
+					     "%s %s :%s", command, chptr->chname, text);
 		}
 	}
 	else
@@ -461,6 +464,11 @@
 		type = ONLY_CHANOPSVOICED;
 		c = '+';
 	}
+	else if(flags & CHFL_HALFOP)
+	{
+		type = ONLY_CHANOPSHALFOPS;
+		c = '%';
+	}
 	else
 	{
 		type = ONLY_CHANOPS;
@@ -505,8 +513,7 @@
 	{
 		sendto_realops_flags(UMODE_DEBUG, L_ALL,
 				"Send message to %s[%s] dropped from %s(Fake Dir)",
-				target_p->name, target_p->from->name,
-				source_p->name);
+				     target_p->name, target_p->from->name, source_p->name);
 		return;
 	}
 
@@ -564,8 +571,7 @@
 			 * and flooding    -- fl */
 			if(!MyClient(source_p) || IsOper(source_p) ||
 			   !flood_attack_client(p_or_n, source_p, target_p))
-				sendto_anywhere(target_p, source_p, command,
-						":%s", text);
+				sendto_anywhere(target_p, source_p, command, ":%s", text);
 		}
 	}
 	else if(!MyClient(source_p) || IsOper(source_p) ||
@@ -742,8 +748,7 @@
 		if(!IsMe(target_p))
 		{
 			sendto_one(target_p, ":%s %s %s :%s", 
-				   get_id(source_p, target_p), 
-				   command, nick, text);
+				   get_id(source_p, target_p), command, nick, text);
 			return;
 		}
 
@@ -775,12 +780,10 @@
 				*--host = '%';
 
 			if(count == 1)
-				sendto_anywhere(target_p, source_p, command, 
-						":%s", text);
+				sendto_anywhere(target_p, source_p, command, ":%s", text);
 			else
 				sendto_one(source_p, form_str(ERR_TOOMANYTARGETS),
-					   get_id(&me, source_p),
-					   get_id(source_p, source_p), nick);
+					   get_id(&me, source_p), get_id(source_p, source_p), nick);
 		}
 	}
 
@@ -808,7 +811,7 @@
 					   form_str(ERR_NOTOPLEVEL), nick);
 			return;
 		}
-		while (*++s)
+		while(*++s)
 			if(*s == '.' || *s == '*' || *s == '?')
 				break;
 		if(*s == '*' || *s == '?')
@@ -851,8 +854,7 @@
 			c2ptr = ptr->data;
 			if(!MyClient(c2ptr))	/* implies mine and an user */
 				continue;
-			if((!host || match(host, c2ptr->host)) &&
-			   irccmp(u, c2ptr->username) == 0)
+			if((!host || match(host, c2ptr->host)) && irccmp(u, c2ptr->username) == 0)
 			{
 				(*count)++;
 				res = c2ptr;
